package salesman_2;

import java.awt.Graphics;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.ReentrantLock;

public class Market {

    int x, y;
    int w,h;
    //maksimalno resursa
    int capacity;
    //trenutno resursa
    int quantity;
    //eksplicitni katanac
    ReentrantLock rlock=new ReentrantLock();
    //Kondicionali, u javi ih jos zovemo i monitori
    //prvi se odnosi na uslov kada trziste nije skroz puno
    //i tada trziste moze da otkupi od trgovca neku kolicinu
    Condition notFull=rlock.newCondition();
    //drugi se odnosi na uslov kada trziste nije skroz prazno
    //i tada moze da proda
    Condition notEmpty=rlock.newCondition();
    
    
    public Market(int x, int y, int w, int h, int c, int q) {
	this.x=x;
	this.y=y;
	this.w=w;
	this.h=h;
	this.capacity=c;
	this.quantity=q;
	
    }
    
    void buy(Salesman s){
	//kupi resurs od trgovca
	rlock.lock();
	
	try{
	    //dok je trenutna kolicina + ono sto nosi trgovac
	    //vec od kapaciteta trzista, trziste ne moze da otkupi
	    while(s.capacity+quantity>capacity)
		notFull.await();
	    s.full=false;
	    quantity=quantity+s.capacity;
	    //kada je otkupilo, javljamo svima da sigurno nesto ima 
	    //na trzistu, i na taj nacin mozda pomazemo drugim trgovcima
	    //koju pokusavaju da otkupe od trzista
	    notEmpty.signalAll();
	    
	}catch (Exception e) {
	    // TODO: handle exception
	}finally{
	    rlock.unlock();
	}
    }
    

    void sell(Salesman s){
	
	rlock.lock();
	
	try{
	    //cekamo dok tren. kolicina na trzistu nije
	    //dovoljna da podmiri trgovca
	    while(s.capacity>quantity)
		notEmpty.await();
	    s.full=true;
	    quantity=quantity-s.capacity;
	    //nakon toga obavestavamo trgovce koji pokusavaju 
	    //da prodaju, da mozda njihova kolicina mozda moze 
	    //da bude otkupljena
	    notFull.signalAll();
	    
	}catch (Exception e) {
	    // TODO: handle exception
	}finally{
	    rlock.unlock();
	}
    }
    
    void doSale(Salesman s){
	//trgovac moze i da kupi i da proda
	//ako je "pun" onda je u svojstvu prodavca
	//inace je u svojstvu kupca
	if(s.full){
	    buy(s);
	}else{
	    sell(s);
	}
    }
    
    boolean contains(int sx, int sy){
	if(sx>=x && sx<=x+w && sy>=y && sy<=y+h)
	    return true;
	return false;
    }
    
    void drawSelf(Graphics g){
	//svako iscrtava sebe
	g.drawRect(x, y, w,h);
	g.drawString(quantity+"/"+capacity, x+w/2, y+h/3);
    }
}
